mod cli;
mod lm_sensors;
mod nvidia_smi;
use cli::Arguments;
use lm_sensors::sensors_data;
use nvidia_smi::temperature;
use structopt::StructOpt;

fn main() {
    let opts = Arguments::from_args();
    match opts {
        Arguments::CPU => print_cpu_temp(),
        Arguments::GPU => print_gpu_temp(),
    }
}

fn print_cpu_temp() {
    let sensors_data = sensors_data();
    match sensors_data {
        Ok(sensors) => {
            let cpu_chip = sensors.cpu_chip();
            if let Some(chip) = cpu_chip {
                if let Some(temp) = chip.temp() {
                    println!("{}", temp);
                }
            }
        }
        Err(_) => {}
    }
}

fn print_gpu_temp() {
    let gpu_temp_data = temperature();
    match gpu_temp_data {
        Ok(temp) => println!("{}", temp),
        Err(_) => {}
    }
}
